﻿Imports System.IO.Ports

Public Class DotnetTermControl
    Private WithEvents port As New SharedSerialClass

    Dim SerialTermainalForm As serial_terminal

    Dim sw_ascii_log As System.IO.StreamWriter
    Dim VersionStringGood As String = "STP100 V2.3"

    Private Function timestamp_filename()
        Dim ts As Date = Now()
        Return ts.ToString("yyyy-MM-dd-hh-mm-ss")
    End Function

    Private Function timestamp()
        Dim ts As Date = Now()
        Dim tsd As Double

        tsd = ts.Hour * 3600.0 + ts.Minute * 60.0 + ts.Second + ts.Millisecond / 1000.0

        Return ts.ToString("MM/dd/yyyy") + vbTab + ts.ToString("hh:mm:ss") + vbTab + tsd.ToString
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Get a list of serial port names.
        Dim ports As String() = SerialPort.GetPortNames()

        ' Display each port name to the console.
        Dim port As String
        For Each port In ports
            CommPortComboBox.Items.Add(port)
        Next port
        CommPortComboBox.SelectedIndex = 0
    End Sub

    Private Sub PortOpenCloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PortOpenCloseButton.Click
        Try
            If Not IsNothing(port) Then
                If port.isOpen Then
                    port.Close()
                    PortOpenCloseButton.Text = "Open"
                    Exit Sub
                End If
            Else
                port = New SharedSerialClass
            End If

            port.PortName = CommPortComboBox.SelectedItem
            port.DtrEnable = True
            If (RadioButton1.Checked = True) Then port.Handshake = System.IO.Ports.Handshake.None
            If (RadioButton2.Checked = True) Then port.Handshake = System.IO.Ports.Handshake.RequestToSend
            If (RadioButton3.Checked = True) Then port.Handshake = System.IO.Ports.Handshake.XOnXOff
            If (RadioButton4.Checked = True) Then port.Handshake = System.IO.Ports.Handshake.RequestToSendXOnXOff
            port.BaudRate = Integer.Parse(BitRateComboBox.Text)

            port.Open()
            PortOpenCloseButton.Text = "Close"

        Catch ex As Exception
            MsgBox("PortOpenCloseButton_Click: " + ex.Message)
        End Try
        Me.Terminal_Click(sender, e)
    End Sub

    Private Sub Terminal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Terminal.Click
        If IsNothing(SerialTermainalForm) Then
            SerialTermainalForm = New serial_terminal(port)
        Else
            SerialTermainalForm.Close()
            SerialTermainalForm = New serial_terminal(port)
        End If
        SerialTermainalForm.Show()
        SerialTermainalForm.Location = New Point(Me.Location.X, Me.Height + Me.Location.Y)
    End Sub

    Private Function SendString(ByVal input As String, Optional ByVal addnewline As Boolean = False) As String
        If port.isOpen Then
            If addnewline Then
                'Return port.WriteReadLine(input + If(addnewline, vbCrLf, vbCr))
                Return port.WriteReadLine(input + vbCrLf)
            Else
                Return port.WriteReadLine(input + vbCr)
            End If
        Else
            Return ""
        End If
    End Function

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        Dim Exercise As String = tbExerciseString.Text
        While CheckBox1.Checked = True
            SendString(Exercise, cbWantNewLine.Checked)
        End While
    End Sub
End Class
