﻿Public Class serial_terminal
    Dim port As SharedSerialClass
    Dim TextTermainal As String = ""

    Private Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Public Sub New(ByRef port As SharedSerialClass)
        Me.New()
        Me.port = port
        AddHandler port.TerminalData, AddressOf Me.SerialCallbackTerminal
    End Sub

    Private Sub serial_terminal_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        RemoveHandler port.TerminalData, AddressOf Me.SerialCallbackTerminal
    End Sub

    Delegate Sub UpdateTerminal(ByVal Text As String)

    Private Sub UpdateTerminal_Callback(ByVal Text As String)
        TerminalBox.AppendText(Text)
    End Sub

    Private Sub SerialCallbackText(ByVal sneder As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs)
        Dim Text As String = ""

        Text = port.ReadMutex()
        Text = Text.Replace(vbCr, vbCrLf)

        TextTermainal += Text
    End Sub

    Private Sub SerialCallbackTerminal(ByVal sender As Object, ByRef Text As String)
        If Not (TerminalBox Is Nothing) Then
            If TerminalBox.InvokeRequired Then
                ' It's on a different thread, so use Invoke.
                Dim d As New UpdateTerminal(AddressOf UpdateTerminal_Callback)
                Try
                    Me.Invoke(d, New Object() {Text})
                Catch ex As Exception
                    Debug.Print("SerialCallbackTerminal: " + ex.Message)
                End Try
            Else
                UpdateTerminal_Callback(Text)
            End If
        Else
            MsgBox("TextBox2 not defined!")
        End If
    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TerminalCommand.KeyPress
        If e.KeyChar = vbCr Then
            Dim delta_ms As Integer
            Dim start As DateTime
            Dim time As New TimeSpan
            Try
                If IsNothing(port) = False Then
                    If port.isOpen = True Then
                        start = Now
                        TerminalBox.AppendText(port.WriteReadLine(TerminalCommand.Text + vbCr) + vbCrLf)
                        time = Now - start
                        delta_ms = (time.Seconds) * 1000 + time.Milliseconds
                        Debug.Print("ms: " + delta_ms.ToString)
                    End If
                End If
                e.Handled = True
            Catch ex As Exception
                Debug.Print("TextBox1_KeyPress:" + ex.Message)
            End Try
        End If
    End Sub

    Private Sub CopyOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyOutput.Click
        TerminalBox.SelectAll()
        TerminalBox.Copy()
    End Sub

    Private Sub ClearTermButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearTermButton.Click
        TerminalBox.Clear()
    End Sub
End Class
